=== debian/changelog ===
bornagain (23.0-6) unstable; urgency=medium

  * d/test/gui: check that bornagain start without error.
  * Bug fix: "cannot open shared object file: No such file or directory",
    thanks to Frederic-Emmanuel Picca (Closes: #1126534).
  * Bug fix: "move from twitter-bootstrap{3,4} to bootstrap-html (v5)",
    thanks to santiagorr@riseup.net</a>; (Closes: #1088448).

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Tue, 10 Feb 2026 16:28:12 +0100

bornagain (23.0-5) unstable; urgency=medium

  * Team upload.
  * Only test against default Python interpreter (Closes: #1125743).
  * Drop unneeded Priority:optional and R3:no fields.
  * Update Standards-Version to 4.7.3 (no changes required).
  * Override some lintian noise to improve usefulness of output.

 -- Stuart Prescott <stuart@debian.org>  Wed, 21 Jan 2026 12:49:37 +1100

bornagain (23.0-4) unstable; urgency=medium

  * Loosen tolerance a bit for one test.

 -- Roland Mas <lolando@debian.org>  Fri, 15 Aug 2025 17:33:36 +0200

bornagain (23.0-3) unstable; urgency=medium

  * Fix arch:all-only builds.

 -- Roland Mas <lolando@debian.org>  Fri, 15 Aug 2025 15:36:56 +0200

bornagain (23.0-2) unstable; urgency=medium

  * Versioned build-depends on libcerf-dev.

 -- Roland Mas <lolando@debian.org>  Wed, 13 Aug 2025 17:37:46 +0200

bornagain (23.0-1) unstable; urgency=medium

  * New upstream release.

 -- Roland Mas <lolando@debian.org>  Wed, 13 Aug 2025 15:41:22 +0200
