=== debian/rules ===
#!/usr/bin/make -f
# output every command that modifies files on the build system.
export DH_VERBOSE = 1

# deal with profiles
CONFIG_SWITCHES=-DCMAKE_DEB_HOST_MULTIARCH=$(DEB_HOST_MULTIARCH)

ifneq ($(filter nodoc,$(DEB_BUILD_PROFILES)),)
	CONFIG_SWITCHES += -DCONFIGURE_DOXY=OFF
else
	CONFIG_SWITCHES += -DCONFIGURE_DOXY=ON
endif

ifneq ($(filter nopython,$(DEB_BUILD_PROFILES)),)
	CONFIG_SWITCHES += -DBORNAGAIN_PYTHON=OFF -DCONFIGURE_BINDINGS=OFF
else
	CONFIG_SWITCHES += -DBORNAGAIN_PYTHON=ON -DCONFIGURE_BINDINGS=ON
endif

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
CFLAGS+=$(CPPFLAGS)
CXXFLAGS+=$(CPPFLAGS)

export CMAKE_OPTIONS := \
  -DCMAKE_CXX_FLAGS="$(CXXFLAGS)" \
  -DCMAKE_SHARED_LINKER_FLAGS_RELEASE="$(LDFLAGS)" \
  -DCMAKE_PREFIX_PATH="/usr/share/cmake/heinz;/usr/share/cmake/formfactor" \
  -DCMAKE_LIBRARY_PATH=/usr/lib/$(DEB_HOST_MULTIARCH)/bornagain \
  -DCMAKE_BUILD_TYPE=Release \
  -DBA_3ARCH=ON

%:
	dh $@

execute_after_dh_clean:
	find auto -name *.pyc -delete

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_OPTIONS) $(CONFIG_SWITCHES) -DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH)

override_dh_auto_test: export MPLCONFIGDIR=$(CURDIR)
override_dh_auto_test:
	cd obj-$(DEB_HOST_GNU_TYPE) && make -j test ARGS\+=--verbose ARGS\+=-j

override_dh_auto_build-arch:
	dh_auto_build

override_dh_auto_build-indep:
	dh_auto_build
	cd hugo && hugo

execute_after_dh_auto_install:
	find debian/tmp -name __pycache__ | xargs -r rm -r
	rm -f debian/tmp/usr/share/BornAgain/bornagain_build.log

execute_after_dh_install-arch:
	find debian/python3-bornagain -name _libBornAgainGUI.so -delete

override_dh_shlibdeps:
	dh_shlibdeps -l /usr/lib/$(DEB_HOST_GNU_TYPE)/bornagain/
