=== debian/tests/control ===
Tests: python3
Depends:
 python3,
 python3-bornagain,
Restrictions: allow-stderr

Test-Command: xvfb-run -s "-screen 0 1024x768x24 -ac +extension GLX +render -noreset" sh debian/tests/gui
Depends:
 bornagain,
 debhelper,
 mesa-utils,
 xauth,
 xvfb,
Restrictions: allow-stderr
